Kyoto Cabinet: kyotocabinet::TextDB Class Reference

Kyoto Cabinet

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Protected Member Functions
kyotocabinet::TextDB Class Reference

Plain text database. More...

`#include <kctextdb.h>`

List of all members.

## Classes
class | Cursor
| Cursor to indicate a record. More...
class | ScopedVisitor
| Scoped visitor.
## Public Member Functions
| TextDB ()
| Default constructor.
virtual | ~TextDB ()
| Destructor.
bool | accept (const char *kbuf, size_t ksiz, Visitor *visitor, bool writable=true)
| Accept a visitor to a record.
bool | accept_bulk (const std::vector< std::string > &keys, Visitor *visitor, bool writable=true)
| Accept a visitor to multiple records at once.
bool | iterate (Visitor *visitor, bool writable=true, ProgressChecker *checker=NULL)
| Iterate to accept a visitor for each record.
bool | scan_parallel (Visitor *visitor, size_t thnum, ProgressChecker *checker=NULL)
| Scan each record in parallel.
Error | error () const
| Get the last happened error.
void | set_error (const char *file, int32_t line, const char *func, Error::Code code, const char *message)
| Set the error information.
bool | open (const std::string &path, uint32_t mode=OWRITER|OCREATE)
| Open a database file.
bool | close ()
| Close the database file.
bool | synchronize (bool hard=false, FileProcessor *proc=NULL, ProgressChecker *checker=NULL)
| Synchronize updated contents with the file and the device.
bool | occupy (bool writable=true, FileProcessor *proc=NULL)
| Occupy database by locking and do something meanwhile.
bool | begin_transaction (bool hard=false)
| Begin transaction.
bool | begin_transaction_try (bool hard=false)
| Try to begin transaction.
bool | end_transaction (bool commit=true)
| End transaction.
bool | clear ()
| Remove all records.
int64_t | count ()
| Get the number of records.
int64_t | size ()
| Get the size of the database file.
std::string | path ()
| Get the path of the database file.
bool | status (std::map< std::string, std::string > *strmap)
| Get the miscellaneous status information.
Cursor * | cursor ()
| Create a cursor object.
void | log (const char *file, int32_t line, const char *func, Logger::Kind kind, const char *message)
| Write a log message.
bool | tune_logger (Logger *logger, uint32_t kinds=Logger::WARN|Logger::ERROR)
| Set the internal logger.
bool | tune_meta_trigger (MetaTrigger *trigger)
| Set the internal meta operation trigger.
## Protected Member Functions
void | report (const char *file, int32_t line, const char *func, Logger::Kind kind, const char *format,...)
| Report a message for debugging.
void | report_valist (const char *file, int32_t line, const char *func, Logger::Kind kind, const char *format, va_list ap)
| Report a message for debugging with variable number of arguments.
void | report_binary (const char *file, int32_t line, const char *func, Logger::Kind kind, const char *name, const char *buf, size_t size)
| Report the content of a binary buffer for debugging.
void | trigger_meta (MetaTrigger::Kind kind, const char *message)
| Trigger a meta database operation.

## Detailed Description

Plain text database.

Note:
  Although this class is designed to use a text file as a database file, not all methods are implemented. Each line in the text is treated as a record. When storing a record, the key is ignored and the value only is appended at the end of the file. Records can be retrieved only by the iterator and the cursor mechanisms. No record can be retrieved by specifying the key. When accessing a record by the iterator, the key is given as the offset from the beginning of the file for descriptive purposes. Any existing record cannot be modified and deleted.

## Constructor & Destructor Documentation

kyotocabinet::TextDB::TextDB | ( |  | ) | `[explicit]`

Default constructor.

virtual kyotocabinet::TextDB::~TextDB | ( |  | ) | `[virtual]`

Destructor.

Note:
  If the database is not closed, it is closed implicitly.

## Member Function Documentation

bool kyotocabinet::TextDB::accept | ( | const char * | kbuf,
|  | size_t | ksiz,
|  | Visitor * | visitor,
|  | bool | writable = `true`
| ) |  | `[virtual]`

Accept a visitor to a record.

Parameters:

  kbuf | the pointer to the key region.
  ksiz | the size of the key region.
  visitor | a visitor object.
  writable | true for writable operation, or false for read-only operation.

Returns:
  true on success, or false on failure.

Note:
  No record can be retrieved by specifying the key and the Visitor::visit_empty method is always called. To avoid deadlock, any explicit database operation must not be performed in this function.

Implements kyotocabinet::DB.

bool kyotocabinet::TextDB::accept_bulk | ( | const std::vector< std::string > & | keys,
|  | Visitor * | visitor,
|  | bool | writable = `true`
| ) |  | `[virtual]`

Accept a visitor to multiple records at once.

Parameters:

  keys | specifies a string vector of the keys.
  visitor | a visitor object.
  writable | true for writable operation, or false for read-only operation.

Returns:
  true on success, or false on failure.

Note:
  No record can be retrieved by specifying the key and the Visitor::visit_empty method is always called. To avoid deadlock, any explicit database operation must not be performed in this function.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::iterate | ( | Visitor * | visitor,
|  | bool | writable = `true`,
|  | ProgressChecker * | checker = `NULL`
| ) |  | `[virtual]`

Iterate to accept a visitor for each record.

Parameters:

  visitor | a visitor object.
  writable | true for writable operation, or false for read-only operation.
  checker | a progress checker object. If it is NULL, no checking is performed.

Returns:
  true on success, or false on failure.

Note:
  The key is generated from the offset of each record. To avoid deadlock, any explicit database operation must not be performed in this function.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::scan_parallel | ( | Visitor * | visitor,
|  | size_t | thnum,
|  | ProgressChecker * | checker = `NULL`
| ) |  | `[virtual]`

Scan each record in parallel.

Parameters:

  visitor | a visitor object.
  thnum | the number of worker threads.
  checker | a progress checker object. If it is NULL, no checking is performed.

Returns:
  true on success, or false on failure.

Note:
  This function is for reading records and not for updating ones. The return value of the visitor is just ignored. The key is generated from the offset of each record. To avoid deadlock, any explicit database operation must not be performed in this function.

Implements kyotocabinet::BasicDB.

Error kyotocabinet::TextDB::error | ( |  | ) | const`[virtual]`

Get the last happened error.

Returns:
  the last happened error.

Implements kyotocabinet::BasicDB.

void kyotocabinet::TextDB::set_error | ( | const char * | file,
|  | int32_t | line,
|  | const char * | func,
|  | Error::Code | code,
|  | const char * | message
| ) |  |

Set the error information.

Parameters:

  file | the file name of the program source code.
  line | the line number of the program source code.
  func | the function name of the program source code.
  code | an error code.
  message | a supplement message.

bool kyotocabinet::TextDB::open | ( | const std::string & | path,
|  | uint32_t | mode = `OWRITER | OCREATE`
| ) |  | `[virtual]`

Open a database file.

Parameters:

  path | the path of a database file.
  mode | the connection mode. TextDB::OWRITER as a writer, TextDB::OREADER as a reader. The following may be added to the writer mode by bitwise-or: TextDB::OCREATE, which means it creates a new database if the file does not exist, TextDB::OTRUNCATE, which means it creates a new database regardless if the file exists, TextDB::OAUTOTRAN, which means each updating operation is performed in implicit transaction, TextDB::OAUTOSYNC, which means each updating operation is followed by implicit synchronization with the file system. The following may be added to both of the reader mode and the writer mode by bitwise-or: TextDB::ONOLOCK, which means it opens the database file without file locking, TextDB::OTRYLOCK, which means locking is performed without blocking, TextDB::ONOREPAIR, which means the database file is not repaired implicitly even if file destruction is detected.

Returns:
  true on success, or false on failure.

Note:
  Every opened database must be closed by the TextDB::close method when it is no longer in use. It is not allowed for two or more database objects in the same process to keep their connections to the same database file at the same time.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::close | ( |  | ) | `[virtual]`

Close the database file.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::synchronize | ( | bool | hard = `false`,
|  | FileProcessor * | proc = `NULL`,
|  | ProgressChecker * | checker = `NULL`
| ) |  | `[virtual]`

Synchronize updated contents with the file and the device.

Parameters:

  hard | true for physical synchronization with the device, or false for logical synchronization with the file system.
  proc | a postprocessor object. If it is NULL, no postprocessing is performed.
  checker | a progress checker object. If it is NULL, no checking is performed.

Returns:
  true on success, or false on failure.

Note:
  The operation of the postprocessor is performed atomically and other threads accessing the same record are blocked. To avoid deadlock, any explicit database operation must not be performed in this function.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::occupy | ( | bool | writable = `true`,
|  | FileProcessor * | proc = `NULL`
| ) |  | `[virtual]`

Occupy database by locking and do something meanwhile.

Parameters:

  writable | true to use writer lock, or false to use reader lock.
  proc | a processor object. If it is NULL, no processing is performed.

Returns:
  true on success, or false on failure.

Note:
  The operation of the processor is performed atomically and other threads accessing the same record are blocked. To avoid deadlock, any explicit database operation must not be performed in this function.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::begin_transaction | ( | bool | hard = `false` | ) | `[virtual]`

Begin transaction.

Parameters:

  hard | true for physical synchronization with the device, or false for logical synchronization with the file system.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::begin_transaction_try | ( | bool | hard = `false` | ) | `[virtual]`

Try to begin transaction.

Parameters:

  hard | true for physical synchronization with the device, or false for logical synchronization with the file system.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::end_transaction | ( | bool | commit = `true` | ) | `[virtual]`

End transaction.

Parameters:

  commit | true to commit the transaction, or false to abort the transaction.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::clear | ( |  | ) | `[virtual]`

Remove all records.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::DB.

int64_t kyotocabinet::TextDB::count | ( |  | ) | `[virtual]`

Get the number of records.

Returns:
  the number of records, or -1 on failure.

Implements kyotocabinet::DB.

int64_t kyotocabinet::TextDB::size | ( |  | ) | `[virtual]`

Get the size of the database file.

Returns:
  the size of the database file in bytes, or -1 on failure.

Implements kyotocabinet::BasicDB.

std::string kyotocabinet::TextDB::path | ( |  | ) | `[virtual]`

Get the path of the database file.

Returns:
  the path of the database file, or an empty string on failure.

Implements kyotocabinet::BasicDB.

bool kyotocabinet::TextDB::status | ( | std::map< std::string, std::string > * | strmap | ) | `[virtual]`

Get the miscellaneous status information.

Parameters:

  strmap | a string map to contain the result.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::BasicDB.

Cursor* kyotocabinet::TextDB::cursor | ( |  | ) | `[virtual]`

Create a cursor object.

Returns:
  the return value is the created cursor object.

Note:
  Because the object of the return value is allocated by the constructor, it should be released with the delete operator when it is no longer in use.

Implements kyotocabinet::BasicDB.

void kyotocabinet::TextDB::log | ( | const char * | file,
|  | int32_t | line,
|  | const char * | func,
|  | Logger::Kind | kind,
|  | const char * | message
| ) |  |

Write a log message.

Parameters:

  file | the file name of the program source code.
  line | the line number of the program source code.
  func | the function name of the program source code.
  kind | the kind of the event. Logger::DEBUG for debugging, Logger::INFO for normal information, Logger::WARN for warning, and Logger::ERROR for fatal error.
  message | the supplement message.

bool kyotocabinet::TextDB::tune_logger | ( | Logger * | logger,
|  | uint32_t | kinds = `Logger::WARN | Logger::ERROR`
| ) |  |

Set the internal logger.

Parameters:

  logger | the logger object.
  kinds | kinds of logged messages by bitwise-or: Logger::DEBUG for debugging, Logger::INFO for normal information, Logger::WARN for warning, and Logger::ERROR for fatal error.

Returns:
  true on success, or false on failure.

bool kyotocabinet::TextDB::tune_meta_trigger | ( | MetaTrigger * | trigger | ) |

Set the internal meta operation trigger.

Parameters:

  trigger | the trigger object.

Returns:
  true on success, or false on failure.

void kyotocabinet::TextDB::report | ( | const char * | file,
|  | int32_t | line,
|  | const char * | func,
|  | Logger::Kind | kind,
|  | const char * | format,
|  |  | ...
| ) |  | `[protected]`

Report a message for debugging.

Parameters:

  file | the file name of the program source code.
  line | the line number of the program source code.
  func | the function name of the program source code.
  kind | the kind of the event. Logger::DEBUG for debugging, Logger::INFO for normal information, Logger::WARN for warning, and Logger::ERROR for fatal error.
  format | the printf-like format string.
  ... | used according to the format string.

void kyotocabinet::TextDB::report_valist | ( | const char * | file,
|  | int32_t | line,
|  | const char * | func,
|  | Logger::Kind | kind,
|  | const char * | format,
|  | va_list | ap
| ) |  | `[protected]`

Report a message for debugging with variable number of arguments.

Parameters:

  file | the file name of the program source code.
  line | the line number of the program source code.
  func | the function name of the program source code.
  kind | the kind of the event. Logger::DEBUG for debugging, Logger::INFO for normal information, Logger::WARN for warning, and Logger::ERROR for fatal error.
  format | the printf-like format string.
  ap | used according to the format string.

void kyotocabinet::TextDB::report_binary | ( | const char * | file,
|  | int32_t | line,
|  | const char * | func,
|  | Logger::Kind | kind,
|  | const char * | name,
|  | const char * | buf,
|  | size_t | size
| ) |  | `[protected]`

Report the content of a binary buffer for debugging.

Parameters:

  file | the file name of the epicenter.
  line | the line number of the epicenter.
  func | the function name of the program source code.
  kind | the kind of the event. Logger::DEBUG for debugging, Logger::INFO for normal information, Logger::WARN for warning, and Logger::ERROR for fatal error.
  name | the name of the information.
  buf | the binary buffer.
  size | the size of the binary buffer

void kyotocabinet::TextDB::trigger_meta | ( | MetaTrigger::Kind | kind,
|  | const char * | message
| ) |  | `[protected]`

Trigger a meta database operation.

Parameters:

  kind | the kind of the event. MetaTrigger::OPEN for opening, MetaTrigger::CLOSE for closing, MetaTrigger::CLEAR for clearing, MetaTrigger::ITERATE for iteration, MetaTrigger::SYNCHRONIZE for synchronization, MetaTrigger::BEGINTRAN for beginning transaction, MetaTrigger::COMMITTRAN for committing transaction, MetaTrigger::ABORTTRAN for aborting transaction, and MetaTrigger::MISC for miscellaneous operations.
  message | the supplement message.